package com.example.nto_2024_client.register

import com.example.nto_2024_client.register.models.RegisterDTO
import io.ktor.client.HttpClient
import io.ktor.client.engine.cio.CIO
import io.ktor.client.plugins.contentnegotiation.ContentNegotiation
import io.ktor.client.request.basicAuth
import io.ktor.client.request.get
import io.ktor.client.request.post
import io.ktor.client.request.setBody
import io.ktor.serialization.kotlinx.json.json
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.withContext
import kotlinx.serialization.json.Json

class RegisterNetwork {
    val client = HttpClient(CIO){
        install(ContentNegotiation){
            json(Json {
                isLenient = true
                ignoreUnknownKeys = true
            })

        }
    }

    suspend fun register(name:String,password:String,login:String):Result<Unit> = withContext(Dispatchers.IO){
        runCatching {
            val result = client.post(""){
                basicAuth(login,password)
                setBody(RegisterDTO(
                    name = name,
                    password = password,
                    username = login
                ))
            }
        }
    }


}